<template>
  <div class="data-table__cell data-table-header" :class="{ 'data-table-header--is-active': isSortActive(fieldName)}">
    <h3 class="data-table-header__title">{{ computedTitle }}</h3>
    <div class="data-table-header__icons" @click="sort(fieldName)">
      <span class="material-icons-outlined data-table-header__icon" :class="{ 'data-table-header__icon--is-active': isSortActive(fieldName)}">sort</span>
      <span v-if="!isSortActive(fieldName) || isSortOrderDescending" class="material-icons-outlined data-table-header__icon" :class="{ 'data-table-header__icon--is-active': isSortActive(fieldName)}">keyboard_arrow_down</span>
      <span v-else class="material-icons-outlined data-table-header__icon" :class="{ 'data-table-header__icon--is-active': isSortActive(fieldName)}">keyboard_arrow_up</span>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapActions, mapState } from 'vuex';
import { Sort, SortOrder } from '@/types/index';

declare module 'vue/types/vue' {
  interface Vue {
    setSort: (fieldName: string) => void;
  }
}

export default Vue.extend({
  name: 'DataTableHeader',

  props: {
    fieldName: {
      required: true,
      type: String
    },

    title: {
      type: String
    }
  },

  computed: {
    ...mapState({
      activeSort: (state: any) => state.characters.activeSort as Sort
    }),

    isSortOrderDescending () {
      return this.activeSort.order === SortOrder.descending;
    },

    computedTitle () {
      return this.title ? this.title : this.fieldName;
    }
  },

  methods: {
    ...mapActions([
      'setSort'
    ]),

    isSortActive (fieldName: string): boolean {
      return this.activeSort.fieldName === fieldName;
    },

    sort (fieldName: string): void {
      this.setSort(fieldName);
    }
  }
});
</script>

<style lang="scss" scoped>
.data-table-header {
  &__title {
    text-transform: capitalize;
    font-size: 1rem;
  }

  &__icons {
    display: flex;
  }

  &__icon {
    cursor: pointer;
    opacity: .5;
    transition: opacity 180ms ease-in-out;
  }

  &--is-active {
    .data-table-header__icon {
      opacity: 1;
    }
  }
}
</style>
